#include "FirstOptScheduling.h"

FirstOptScheduling::FirstOptScheduling()
{

}

FirstOptScheduling::~FirstOptScheduling()
{

}

double FirstOptScheduling::pressureDifference(const std::vector<double>& HC, const std::vector<double>& HF)
{
	if (HC.size() != HF.size())
		return 0;

	size_t total = HC.size();
	double result = 0.0;
	for (int i = 0; i < total; i++)
	{
		result += (HC[i] - HF[i]);
	}
	return result;
}

double FirstOptScheduling::pumpPower(const PumpStruct& pumpParam)
{
	std::vector<double>  s1 =  pumpParam.mS1;
	double a = pumpParam.a;

	int total = s1.size();
	double result = 0.0;
	for (int i = 0; i < total; i++)
	{
		result += s1[i];
		// iվĶٱú͵ٱõ
		int columns = pumpParam.mK[i] + pumpParam.mP[i];

		double temp = 0.0; 
		for (int j = 0; j < columns; j++)
		{
			temp +=( (a*pumpParam.mNS[i][j]*pumpParam.mQS[i][j]  \
				*pumpParam.mHS[i][j])/(pumpParam.mX[i][j]*pumpParam.mY[i][j]));
		}
		temp *= pumpParam.mS2[i];
		result += temp;

	}
	return result;
}

double FirstOptScheduling::waterProductionCost(const std::vector<double>& Q, const std::vector<double>& S3)
{
	if (Q.size() != S3.size())
		return 0;

	int total = Q.size();
	double result = 0;
	for (int i = 0; i < total; i++)
	{
		result += (Q[i] * S3[i]);
	}

	return result;
}

double FirstOptScheduling::waterSupplyAndDemand(const std::vector<double>& Q, const double& Qd)
{
	size_t total = Q.size();
	double result = 0;
	for (int i = 0; i < total; i++)
	{
		result += Q[i];
	}

	return std::abs(result - Qd);
}