#pragma once
#include <iostream>
#include <cstdio>
#include <vector>
#include <queue>

#define  IN
#define OUT
#define INOUT


class CivDbConn;

/**
 *@brief  ߱ 
 *@param weight Ȩ
 */
template <class EdgeType>
struct Edge
{
    int nDestVertex; // ñָĶλ

    EdgeType edgeObj;  // ߵֵ

    Edge<EdgeType>* pNextEdge; // һָ

    Edge()
    { }

    Edge(int d, EdgeType c, Edge<EdgeType>* p = NULL)
        :nDestVertex(d), edgeObj(c), pNextEdge(p)
    {}
};

/**
 *@brief  ڽӱбĶ
 *@param VertexType ڵϢ
 *@param EdgeType Ϣ
 */
template <class VertexType, class EdgeType>
struct Vertex
{
    VertexType mVertex; // Ϣ
    
    Edge<EdgeType>* pAdjEdges; // ָһöĻ

    Vertex(VertexType x, Edge<EdgeType>* p = NULL)
        :mVertex(x), pAdjEdges(p)
    {}
};

/**
   ڽӱͼ
*/
template <class  VertexType, class EdgeType>
class ALGraph
{
public:
    ALGraph();
    ~ALGraph();

    void getVisitedResult(IN const VertexType& vetexType,OUT std::vector<VertexType>& vertex,OUT std::vector<EdgeType>& edges);

    void BFS(IN VertexType vetexType, OUT std::vector<int>& visited);

    /**
    *@brief ڽӱ
    */
    ALGraph<VertexType, EdgeType>* reverseGraph();

    /**
    *@brief ͼвһڵ
    *@param vertexName ڵֵ
    */
    bool insertAVertex(IN const VertexType& vertexName);

    /**
    *@brief ڵ֮һ
    *@param vertexName1 ڵ1
    *@param vertexName2 ڵ2
    *@param edge 
    */
    bool insertAEdge(IN const VertexType& vertexName1, IN const VertexType& vertexName2, IN const EdgeType& edge);


    /**
    *@brief ͷڵ
    *@param index 
    *@param arcNode ͷڵ
    */
    bool addHeadEdage(IN const int index, IN  Edge<EdgeType>* arcNode);


    bool insertBeforeEdage(IN const int index, IN  Edge<EdgeType>* arcNode);

    /**
    *@brief Ƴڵı
    *@param vertexName1 ڵ1
    *@param vertexName2 ڵ2
    *@param edge 
    */
    bool removeAEdge(IN const VertexType& vertexName1, IN const VertexType& vertexName2, IN const EdgeType& edgeWeight);

    /**
     *@brief ȡڵ֮ӵСȨֵ
     *@param vertexName1  ڵ1
     *@param vertexName2  ڵ2
     */
    EdgeType getMinWeight(IN const VertexType& vertexName1, IN const VertexType& vertexName2);

    /**
     *@brief ȡ
     *@param vertexName  Ψһʶ
     */
    int getVertexIndex(IN const VertexType& vertexName);

    /**
     *@brief ȡ
     */
    int getVertexNumber();

    /**
    *@brief ȡ
    *@param index ֵ
    */
    VertexType getData(IN int index);

private:
    EdgeType getEdgeWeight(IN const Edge<EdgeType>* pEdge);

    void getVertexEdgeWeight(IN const int v1, OUT std::vector<EdgeType>& DistanceArray);

    std::vector<Vertex<VertexType, EdgeType>> mVertexArray; // ڵ
};


template <class VertexType, class EdgeType>
ALGraph<VertexType, EdgeType>::ALGraph()
{

}

template <class VertexType, class EdgeType>
void ALGraph<VertexType, EdgeType>::getVisitedResult(
    IN const VertexType& vetexType,
    OUT std::vector<VertexType>& vertex,
    OUT std::vector<EdgeType>& edges)
{
    std::vector<int> visited;
    BFS(vetexType, visited);

    size_t total = visited.size();
    for (int i = 0; i < total; i++)
    {
        int index = visited[i];
        Vertex<VertexType, EdgeType> vertexTemp = mVertexArray.at(index);
        VertexType vertexType = vertexTemp.mVertex;
        Edge<EdgeType>* pArcNext = vertexTemp.pAdjEdges;

        // 
        vertex.push_back(vertexType);

        // ݣעȥ
        while (pArcNext != nullptr)
        {
            EdgeType edgeType = pArcNext->edgeObj;
            pArcNext = pArcNext->pNextEdge;

            edges.push_back(edgeType);
          
        }
    }
}

template <class VertexType, class EdgeType>
void ALGraph<VertexType, EdgeType>::BFS(IN VertexType vetexType, OUT std::vector<int>& visited)
{
    // ȡ붥
    int vi = getVertexIndex(vetexType);
    if (-1 == vi)
    {
        return;
    }

    Edge<EdgeType>* edageNext;

    // ʼ
    std::queue<int> Q;
    Q.push(vi);

    visited.push_back(vi);
    while (!Q.empty()) {

        int node = Q.front();
        Q.pop();

        edageNext = mVertexArray.at(node).pAdjEdges;
        while (edageNext)
        {
            // δʹķ
            int pVal = edageNext->nDestVertex;

            auto iter = std::find(visited.begin(), visited.end(), pVal);
            if (pVal >-1 && iter == visited.end())
            {
                visited.push_back(pVal);
                Q.push(pVal);
            }

            // 
            edageNext = edageNext->pNextEdge;
        }
    }
}


template <class VertexType, class EdgeType>
ALGraph<VertexType, EdgeType>* ALGraph<VertexType, EdgeType>::reverseGraph()
{
    // һٽͼ
    ALGraph<VertexType, EdgeType>* graph = new   ALGraph<VertexType, EdgeType>();

    size_t vertexSize = mVertexArray.size();
    //ʼͷ
    for (int i = 0; i < vertexSize; i++)
    {
        Vertex<VertexType, EdgeType> vetex = mVertexArray.at(i);
        graph->insertAVertex(vetex.mVertex);

        // ͷڵ
        Edge<EdgeType>* arcNode = new Edge<EdgeType>(-1, EdgeType());
        int index = graph->getVertexIndex(vetex.mVertex);

        // ͷڵ
        graph->addHeadEdage(index, arcNode);
    }

    //лڽӱ
    for (int i = 0; i < vertexSize; i++)
    {
        Vertex<VertexType, EdgeType> vetex = mVertexArray.at(i);
        Edge<EdgeType>* edge = vetex.pAdjEdges;  // iĵһ

        while (edge != nullptr)
        {
            int k = edge->nDestVertex;// ¼ڵλ

            // 
            Edge<EdgeType>* arcNode = new Edge<EdgeType>(i, edge->edgeObj);
            graph->insertBeforeEdage(k, arcNode);

            edge = edge->pNextEdge;
        }
    }

    return graph;
}

template <class VertexType, class EdgeType>
ALGraph<VertexType, EdgeType>::~ALGraph()
{
    for (auto iter = mVertexArray.begin(); iter != mVertexArray.end(); iter++)
    {
        Edge<EdgeType>* p = iter->pAdjEdges;
        while (NULL != p)
        {
            iter->pAdjEdges = p->pNextEdge;
            delete p;
            p = iter->pAdjEdges;
        }
    }
    if (!mVertexArray.empty())
    {
        mVertexArray.clear();
    }
}

template <class VertexType, class EdgeType>
bool ALGraph<VertexType, EdgeType>::insertAVertex(IN const VertexType& vertexName)
{
    Vertex<VertexType, EdgeType> VertexInstance(vertexName, NULL);
    mVertexArray.push_back(VertexInstance);

    return true;
}

template <class VertexType, class EdgeType>
bool ALGraph<VertexType, EdgeType>::addHeadEdage(IN const int index, IN  Edge<EdgeType>* arcNode)
{
    if (index < 0 || index >= mVertexArray.size())
    {
        return false;
    }
    mVertexArray.at(index).pAdjEdges = arcNode;

    return true;
}

template <class VertexType, class EdgeType>
bool ALGraph<VertexType, EdgeType>::insertBeforeEdage(IN const int index, IN Edge<EdgeType>* arcNode)
{
    if (index < 0 && index >= mVertexArray.size())
    {
        return false;
    }
    arcNode->pNextEdge = mVertexArray.at(index).pAdjEdges->pNextEdge;
    mVertexArray.at(index).pAdjEdges->pNextEdge = arcNode;

    return true;
}


template <class VertexType, class EdgeType>
bool ALGraph<VertexType, EdgeType>::insertAEdge(IN const VertexType& vertexName1,
    IN const VertexType& vertexName2, IN const EdgeType& edgeWeight)
{
    int v1 = getVertexIndex(vertexName1);
    if (-1 == v1)
    {

        return false;
    }

    int v2 = getVertexIndex(vertexName2);
    if (-1 == v2)
    {

        return false;
    }

    Edge<EdgeType>* p = mVertexArray.at(v1).pAdjEdges;
    while (p != NULL && p->nDestVertex != v2)
    {
        p = p->pNextEdge;
    }

    if (NULL == p)
    {
        p = new Edge<EdgeType>(v2, edgeWeight, mVertexArray.at(v1).pAdjEdges);
        mVertexArray.at(v1).pAdjEdges = p;
        return true;
    }

    if (v2 == p->nDestVertex)
    {
        Edge<EdgeType>* q = p;
        p = new Edge<EdgeType>(v2, edgeWeight, q->pNextEdge);
        q->pNextEdge = p;
        return true;
    }

    return false;
}

template <class VertexType, class EdgeType>
bool ALGraph<VertexType, EdgeType>::removeAEdge(IN const VertexType& vertexName1,
    IN const VertexType& vertexName2, IN const EdgeType& edgeWeight)
{
    int v1 = getVertexIndex(vertexName1);
    if (-1 == v1)
    {

        return false;
    }

    int v2 = getVertexIndex(vertexName2);
    if (-1 == v2)
    {

        return false;
    }

    Edge<EdgeType>* p = mVertexArray.at(v1).pAdjEdges;
    Edge<EdgeType>* q = NULL;
    while (p != NULL && p->nDestVertex != v2)
    {
        q = p;
        p = p->pNextEdge;
    }

    if (NULL == p)
    {
        return false;
    }

    while (edgeWeight != p->edgeObj && p->nDestVertex == v2)
    {
        q = p;
        p = p->pNextEdge;
    }

    if (v2 != p->nDestVertex)
    {
        return false;
    }

    q->pNextEdge = p->pNextEdge;
    delete p;

    return true;
}

template <class VertexType, class EdgeType>
EdgeType ALGraph<VertexType, EdgeType>::getEdgeWeight(IN const Edge<EdgeType>* pEdge)
{
    return pEdge->edgeObj;
}

template <class VertexType, class EdgeType>
void ALGraph<VertexType, EdgeType>::getVertexEdgeWeight(IN const int v1, OUT  std::vector<EdgeType>& DistanceArray)
{
    Vertex<VertexType, EdgeType> tex = mVertexArray.at(v1);
    Edge<EdgeType>* p = tex.pAdjEdges;

    int prevIndex = -1;
    EdgeType tmp;

    while (NULL != p)
    {
        // ͬı
        if (prevIndex == p->nDestVertex)
        {
            if (tmp > p->edgeWeight)
            {
                DistanceArray[prevIndex] = p->edgeWeight;
            }
        }
        else
        {
            DistanceArray[p->nDestVertex] = p->edgeWeight;
            prevIndex = p->nDestVertex;
            tmp = p->edgeWeight;
        }

        p = p->pNextEdge;
    }
}

template <class VertexType, class EdgeType>
EdgeType ALGraph<VertexType, EdgeType>::getMinWeight(IN const VertexType& vertexName1,
    IN const VertexType& vertexName2)
{
    Edge<EdgeType>* pEdge = NULL;
    int v1 = getVertexIndex(vertexName1);
    if (-1 == v1)
    {
        return false;
    }

    int v2 = getVertexIndex(vertexName2);
    if (-1 == v2)
    {
        return false;
    }

    Edge<EdgeType>* p = mVertexArray.at(v1).pAdjEdges;
    while (p != NULL && p->nDestVertex != v2)
    {
        p = p->pNextEdge;
    }
    if (NULL == p)
    {
        pEdge = NULL;
        return EdgeType(0);
    }
    EdgeType tmp = getEdgeWeight(p);
    pEdge = p;
    while (NULL != p && v2 == p->nDestVertex)
    {
        if (tmp > getEdgeWeight(p))
        {
            tmp = getEdgeWeight(p);
            pEdge = p;
        }
        p = p->pNextEdge;
    }
    return tmp;
}

template <class  VertexType, class EdgeType>
int ALGraph<VertexType, EdgeType>::getVertexIndex(IN const VertexType& vertexName)
{
    for (int i = 0; i < mVertexArray.size(); i++)
    {
        if (vertexName == getData(i))
        {
            return i;
        }
    }
    return -1;
}

template <class   VertexType, class EdgeType>
int ALGraph<VertexType, EdgeType>::getVertexNumber()
{
    return mVertexArray.size();
}

template <class  VertexType, class EdgeType>
VertexType ALGraph<VertexType, EdgeType>::getData(IN int index)
{
    if (index < 0)
        return VertexType();

    Vertex<VertexType, EdgeType> tex = mVertexArray.at(index);
    VertexType vertex = tex.mVertex;
    return vertex;
}



